## mingw-w64-aws-c-common-0.10.0-1.src.tar.zst

=== tests/CMakeLists.txt ===
include(AwsLibFuzzer)
include(AwsTestHarness)
enable_testing()

file(GLOB META_TEST_SRC "assert_test.c")
file(GLOB TEST_BASE_SRC "*.c")
file(GLOB TEST_LOGGING_SRC "logging/*.c")
file(GLOB TEST_SRC ${TEST_BASE_SRC} ${TEST_LOGGING_SRC})
list(REMOVE_ITEM TEST_SRC ${META_TEST_SRC})
file(GLOB TEST_BASE_HDRS "*.h")
file(GLOB TEST_LOGGING_HDRS "logging/*.h")
file(GLOB TEST_HDRS ${TEST_BASE_HDRS} ${TEST_LOGGING_HDRS})
file(GLOB TESTS ${TEST_HDRS} ${TEST_SRC})

set(METATEST_BINARY_NAME ${PROJECT_NAME}-assert-tests)

if(NOT LEGACY_COMPILER_SUPPORT)
    add_executable(${METATEST_BINARY_NAME} ${META_TEST_SRC})
    aws_set_common_properties(${METATEST_BINARY_NAME} NO_WEXTRA NO_PEDANTIC)
    aws_add_sanitizers(${METATEST_BINARY_NAME} ${${PROJECT_NAME}_SANITIZERS})
    target_link_libraries(${METATEST_BINARY_NAME} PRIVATE ${PROJECT_NAME})

    target_compile_definitions(${METATEST_BINARY_NAME} PRIVATE AWS_UNSTABLE_TESTING_API=1)
    target_include_directories(${METATEST_BINARY_NAME} PRIVATE ${CMAKE_CURRENT_LIST_DIR})

    if(MSVC)
        target_compile_definitions(${METATEST_BINARY_NAME} PRIVATE "-D_CRT_SECURE_NO_WARNINGS")
    endif()

    add_test(assert_test ${METATEST_BINARY_NAME} ${CMAKE_CURRENT_BINARY_DIR}/metatest.tmp)
endif()

add_test_case(raise_errors_test)
add_test_case(reset_errors_test)
add_test_case(error_callback_test)
add_test_case(unknown_error_code_in_slot_test)
add_test_case(unknown_error_code_no_slot_test)
add_test_case(unknown_error_code_range_too_large_test)
add_test_case(aws_load_error_strings_test)
add_test_case(aws_assume_compiles_test)

add_test_case(thread_creation_join_test)
add_test_case(thread_creation_join_invalid_cpu_id_test)
add_test_case(thread_atexit_test)
add_test_case(test_managed_thread_join)
add_test_case(test_managed_thread_join_timeout)

add_test_case(mutex_aquire_release_test)
add_test_case(mutex_is_actually_mutex_test)
add_test_case(mutex_try_lock_is_correct_test)

add_test_case(conditional_notify_one)
add_test_case(conditional_notify_all)

add_test_case(error_code_cross_thread_test)

add_test_case(high_res_clock_increments_test)
add_test_case(sys_clock_increments_test)
add_test_case(test_sec_and_millis_conversions)
add_test_case(test_sec_and_micros_conversions)
add_test_case(test_sec_and_nanos_conversions)
add_test_case(test_milli_and_micros_conversion)
add_test_case(test_milli_and_nanos_conversion)
add_test_case(test_micro_and_nanos_conversion)
add_test_case(test_precision_loss_remainders_conversion)
add_test_case(test_overflow_conversion)
add_test_case(test_old_overflow_cases)

add_test_case(array_list_zero_length)
add_test_case(array_list_order_push_back_pop_front_test)
add_test_case(array_list_order_push_back_pop_back_test)
add_test_case(array_list_order_push_front_pop_front_test)
add_test_case(array_list_pop_front_n_test)
add_test_case(array_list_erase_test)
add_test_case(array_list_exponential_mem_model_test)
add_test_case(array_list_exponential_mem_model_iteration_test)
add_test_case(array_list_set_at_overwrite_safety)
add_test_case(array_list_iteration_by_ptr_test)
add_test_case(array_list_iteration_test)
add_test_case(array_list_preallocated_iteration_test)
add_test_case(array_list_preallocated_push_test)
add_test_case(array_list_shrink_to_fit_test)
add_test_case(array_list_shrink_to_fit_static_test)
add_test_case(array_list_clear_test)
add_test_case(array_list_copy_test)
add_test_case(array_list_swap_contents_test)
add_test_case(array_list_not_enough_space_test)
add_test_case(array_list_not_enough_space_test_failure)
add_test_case(array_list_of_strings_sort)
add_test_case(array_list_empty_sort)
add_test_case(priority_queue_push_pop_order_test)
add_test_case(priority_queue_random_values_test)
add_test_case(priority_queue_size_and_capacity_test)
add_test_case(priority_queue_remove_root_test)
add_test_case(priority_queue_remove_leaf_test)
add_test_case(priority_queue_remove_interior_sift_up_test)
add_test_case(priority_queue_remove_interior_sift_down_test)
add_test_case(priority_queue_clear_backpointers_test)

add_test_case(linked_list_push_back_pop_front)
add_test_case(linked_list_push_front_pop_back)
add_test_case(linked_list_swap_nodes)
add_test_case(linked_list_iteration)
add_test_case(linked_list_reverse_iteration)
add_test_case(linked_list_swap_contents)
add_test_case(linked_list_move_all_back)
add_test_case(linked_list_move_all_front)
add_test_case(linked_list_node_in_list)

add_test_case(hex_encoding_test_case_empty_test)
add_test_case(hex_encoding_test_case_f_test)
add_test_case(hex_encoding_test_case_fo_test)
add_test_case(hex_encoding_test_case_foo_test)
add_test_case(hex_encoding_test_case_foob_test)
add_test_case(hex_encoding_test_case_fooba_test)
add_test_case(hex_encoding_test_case_foobar_test)
add_test_case(hex_encoding_test_case_missing_leading_zero)
add_test_case(hex_encoding_invalid_buffer_size_test)
add_test_case(hex_encoding_highbyte_string_test)
add_test_case(hex_encoding_overflow_test)
add_test_case(hex_encoding_invalid_string_test)
add_test_case(hex_encoding_append_dynamic_test_case_empty)
add_test_case(hex_encoding_append_dynamic_test_case_fooba)
add_test_case(base64_encoding_test_case_empty_test)
add_test_case(base64_encoding_test_case_f_test)
add_test_case(base64_encoding_test_case_fo_test)
add_test_case(base64_encoding_test_case_foo_test)
add_test_case(base64_encoding_test_case_foob_test)
add_test_case(base64_encoding_test_case_fooba_test)
add_test_case(base64_encoding_test_case_foobar_test)
add_test_case(base64_encoding_test_case_32bytes_test)
add_test_case(base64_encoding_buffer_size_too_small_test)
add_test_case(base64_encoding_buffer_size_overflow_test)
add_test_case(base64_encoding_buffer_size_invalid_test)
add_test_case(base64_encoding_invalid_buffer_test)
add_test_case(base64_encoding_highbyte_string_test)
add_test_case(base64_encoding_invalid_padding_test)
add_test_case(base64_encoding_test_zeros)
add_test_case(base64_encoding_test_roundtrip)
add_test_case(base64_encoding_test_all_values)
add_test_case(uint64_buffer_test)
add_test_case(uint64_buffer_non_aligned_test)
add_test_case(uint32_buffer_test)
add_test_case(uint32_buffer_non_aligned_test)
add_test_case(uint24_buffer_test)
add_test_case(uint24_buffer_non_aligned_test)
add_test_case(uint16_buffer_test)
add_test_case(uint16_buffer_non_aligned_test)
add_test_case(uint16_buffer_signed_positive_test)
add_test_case(uint16_buffer_signed_negative_test)
add_test_case(text_encoding_utf8)
add_test_case(text_encoding_utf16)
add_test_case(text_encoding_ascii)
add_test_case(text_encoding_is_utf8)
add_test_case(text_is_valid_utf8)
add_test_case(text_is_valid_utf8_callback)
add_test_case(utf8_decoder)

add_test_case(scheduler_cleanup_cancellation)
add_test_case(scheduler_ordering_test)
add_test_case(scheduler_pops_task_late_test)
add_test_case(scheduler_has_tasks_test)
add_test_case(scheduler_reentrant_safe)
add_test_case(scheduler_cleanup_reentrants)
add_test_case(scheduler_schedule_cancellation)
add_test_case(scheduler_cleanup_idempotent)
add_test_case(scheduler_task_delete_on_run)

add_test_case(test_hash_table_create_find)
add_test_case(test_hash_table_string_create_find)
add_test_case(test_hash_table_put)
add_test_case(test_hash_table_put_null_dtor)
add_test_case(test_hash_table_swap_move)
add_test_case(test_hash_table_string_clean_up)
add_test_case(test_hash_table_hash_collision)
add_test_case(test_hash_table_hash_overwrite)
add_test_case(test_hash_table_hash_remove)
add_test_case(test_hash_table_hash_clear_allows_cleanup)
add_test_case(test_hash_table_on_resize_returns_correct_entry)
add_test_case(test_hash_table_foreach)
add_test_case(test_hash_table_iter)
add_test_case(test_hash_table_empty_iter)
add_test_case(test_hash_table_iter_detail)
add_test_case(test_hash_table_eq)
add_test_case(test_hash_churn)
add_test_case(test_hash_table_cleanup_idempotent)
add_test_case(test_hash_table_byte_cursor_create_find)
add_test_case(test_hash_combine)

add_test_case(test_linked_hash_table_preserves_insertion_order)
add_test_case(test_linked_hash_table_entries_cleanup)
add_test_case(test_linked_hash_table_entries_overwrite)
add_test_case(test_linked_hash_table_entries_overwrite_reference_unequal)
add_test_case(test_linked_hash_table_entries_overwrite_backed_cursor)

add_test_case(test_lru_cache_overflow_static_members)
add_test_case(test_lru_cache_lru_ness_static_members)
add_test_case(test_lru_cache_element_access_members)
add_test_case(test_fifo_cache_overflow_static_members)
add_test_case(test_lifo_cache_overflow_static_members)
add_test_case(test_cache_entries_cleanup)
add_test_case(test_cache_entries_overwrite)

add_test_case(test_is_power_of_two)
add_test_case(test_round_up_to_power_of_two)
add_test_case(test_mul_size_checked)
add_test_case(test_mul_size_saturating)
add_test_case(test_mul_u32_checked)
add_test_case(test_mul_u32_saturating)
add_test_case(test_mul_u64_checked)
add_test_case(test_mul_u64_saturating)
add_test_case(test_add_size_checked)
add_test_case(test_aws_add_size_checked_varargs)
add_test_case(test_add_size_saturating)
add_test_case(test_add_u32_checked)
add_test_case(test_add_u32_saturating)
add_test_case(test_add_u64_checked)
add_test_case(test_add_u64_saturating)
add_test_case(test_min_max)
add_test_case(test_clz)
add_test_case(test_ctz)

add_test_case(nospec_index_test)
add_test_case(test_byte_cursor_advance)
add_test_case(test_byte_cursor_advance_nospec)

add_test_case(byte_cursor_write_tests)
add_test_case(byte_cursor_read_tests)
add_test_case(byte_cursor_limit_tests)
add_test_case(test_byte_cursor_read_hex_u8)
add_test_case(test_byte_cursor_right_trim_empty)
add_test_case(test_byte_cursor_right_trim_all_whitespace)
add_test_case(test_byte_cursor_right_trim_basic)
add_test_case(test_byte_cursor_left_trim_empty)
add_test_case(test_byte_cursor_left_trim_all_whitespace)
add_test_case(test_byte_cursor_left_trim_basic)
add_test_case(test_byte_cursor_trim_basic)

add_test_case(string_tests)
add_test_case(binary_string_test)
add_test_case(string_compare_test)
add_test_case(string_destroy_secure_test)
add_test_case(secure_strlen_test)

add_test_case(test_char_split_happy_path)
add_test_case(test_char_split_ends_with_token)
add_test_case(test_char_split_token_not_present)
add_test_case(test_char_split_empty)
add_test_case(test_char_split_zeroed)
add_test_case(test_char_split_adj_tokens)
add_test_case(test_char_split_begins_with_token)
add_test_case(test_char_split_with_max_splits)
add_test_case(test_char_split_output_too_small)
add_test_case(test_byte_cursor_next_split)
add_test_case(test_buffer_cat)
add_test_case(test_buffer_cat_dest_too_small)
add_test_case(test_buffer_cpy)
add_test_case(test_buffer_cpy_dest_too_small)
add_test_case(test_buffer_cpy_offsets)
add_test_case(test_buffer_cpy_offsets_dest_too_small)
add_test_case(test_buffer_eq)
add_test_case(test_buffer_eq_same_content_different_len)
add_test_case(test_buffer_eq_null_internal_byte_buffer)
add_test_case(test_buffer_init_copy)
add_test_case(test_buffer_init_copy_null_buffer)
add_test_case(test_buffer_advance)
add_test_case(test_buffer_printf)
add_test_case(test_array_eq)
add_test_case(test_array_eq_ignore_case)
add_test_case(test_array_eq_c_str)
add_test_case(test_array_eq_c_str_ignore_case)
add_test_case(test_array_hash_ignore_case)
add_test_case(test_byte_buf_write_to_capacity)
add_test_case(test_byte_buf_init_cache_and_update_cursors)
add_test_case(test_byte_buf_empty_appends)
add_test_case(test_byte_buf_append_and_update_fail)
add_test_case(test_byte_buf_append_and_update_success)
add_test_case(test_byte_buf_append_dynamic)
add_test_case(test_byte_buf_append_byte)
add_test_case(test_byte_buf_append_lookup_success)
add_test_case(test_byte_buf_append_lookup_failure)
add_test_case(test_byte_buf_reserve)
add_test_case(test_byte_buf_reserve_initial_capacity_zero)
add_test_case(test_byte_buf_reserve_relative)
add_test_case(test_byte_buf_reserve_smart)
add_test_case(test_byte_buf_reserve_smart_relative)
add_test_case(test_byte_buf_reset)

=== verification/cbmc/proofs/aws_hash_table_put/Makefile ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.

###########
# 2: 6m
# 4: 14m
MAX_TABLE_SIZE ?= 2
DEFINES += -DMAX_TABLE_SIZE=$(MAX_TABLE_SIZE)

UNWINDSET +=__CPROVER_file_local_hash_table_c_s_find_entry1.0:$(shell echo $$((1 + $(MAX_TABLE_SIZE))))
UNWINDSET += __CPROVER_file_local_hash_table_c_s_emplace_item.0:$(shell echo $$((1 + $$(( 2 * $(MAX_TABLE_SIZE) )) )) )

CBMCFLAGS +=

PROOF_UID = aws_hash_table_put
HARNESS_ENTRY = $(PROOF_UID)_harness
HARNESS_FILE = $(PROOFDIR)/$(HARNESS_ENTRY).c

PROOF_SOURCES += $(HARNESS_FILE)
PROOF_SOURCES += $(PROOF_SOURCE)/make_common_data_structures.c
PROJECT_SOURCES += $(SRCDIR)/source/allocator.c
PROOF_SOURCES += $(PROOF_SOURCE)/utils.c

PROOF_SOURCES += $(PROOF_STUB)/error.c
PROOF_SOURCES += $(PROOF_STUB)/memset_override_no_op.c
PROOF_SOURCES += $(PROOF_STUB)/s_emplace_item_override.c
PROOF_SOURCES += $(PROOF_STUB)/s_expand_table_override.c

PROJECT_SOURCES += $(SRCDIR)/source/common.c
PROJECT_SOURCES += $(SRCDIR)/source/hash_table.c

REMOVE_FUNCTION_BODY +=  __CPROVER_file_local_hash_table_c_s_emplace_item
REMOVE_FUNCTION_BODY +=  __CPROVER_file_local_hash_table_c_s_expand_table
REMOVE_FUNCTION_BODY +=  __CPROVER_file_local_allocator_c_s_cf_allocator_copy_description
REMOVE_FUNCTION_BODY +=  __CPROVER_file_local_allocator_c_s_cf_allocator_deallocate

include ../Makefile.common

=== verification/cbmc/proofs/aws_linked_list_front/Makefile ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.

###########

# Run deep validity checks in is_valid
AWS_DEEP_CHECKS = 1

include ../Makefile.aws_linked_list

UNWINDSET += __CPROVER_file_local_linked_list_inl_aws_linked_list_is_valid_deep.0:$(shell echo $$((2 + $(MAX_LINKED_LIST_ITEM_ALLOCATION))))
UNWINDSET += ensure_linked_list_is_allocated.0:$(shell echo $$((1 + $(MAX_LINKED_LIST_ITEM_ALLOCATION))))

CBMCFLAGS +=

PROOF_UID = aws_linked_list_front
HARNESS_ENTRY = $(PROOF_UID)_harness
HARNESS_FILE = $(PROOFDIR)/$(HARNESS_ENTRY).c

PROOF_SOURCES += $(HARNESS_FILE)
PROOF_SOURCES += $(PROOF_SOURCE)/make_common_data_structures.c
PROJECT_SOURCES += $(SRCDIR)/source/allocator.c
PROOF_SOURCES += $(PROOF_SOURCE)/utils.c

PROOF_SOURCES += $(PROOF_STUB)/error.c

# The actual implementation that we're proving comes from .inl files
# that the stubs pull in. Link against an empty file, since we're not
# using any other files from c-common.
PROJECT_SOURCES += $(PROOF_STUB)/empty-source-file.c

###########

include ../Makefile.common

=== verification/cbmc/proofs/aws_priority_queue_s_sift_up/Makefile ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.

###########
include ../Makefile.aws_array_list
include ../Makefile.aws_priority_queue_sift

###########
#
# Runtime:
# - 300s for MAX_PRIORITY_QUEUE_ITEMS=3 items
# - 450s for MAX_PRIORITY_QUEUE_ITEMS=5 items

# Note:
# In order to reach full coverage we need to unwind the harness loop
# as many times as the number of queue items, and the sift down loop
# log(NUMBER_PRIO_QUEUE_ITEMS) times.
UNWINDSET += aws_priority_queue_s_sift_up_harness.0:$(shell echo $$((1 + $(MAX_PRIORITY_QUEUE_ITEMS))))
UNWINDSET += __CPROVER_file_local_priority_queue_c_s_sift_up.0:$(MAX_HEAP_HEIGHT)
UNWINDSET += aws_priority_queue_backpointers_valid_deep.0:$(shell echo $$((1 + $(MAX_PRIORITY_QUEUE_ITEMS))))

CBMCFLAGS +=

PROOF_UID = aws_priority_queue_s_sift_up
HARNESS_ENTRY = $(PROOF_UID)_harness
HARNESS_FILE = $(PROOFDIR)/$(HARNESS_ENTRY).c

PROOF_SOURCES += $(HARNESS_FILE)
PROOF_SOURCES += $(PROOF_SOURCE)/make_common_data_structures.c
PROJECT_SOURCES += $(SRCDIR)/source/allocator.c
PROOF_SOURCES += $(PROOF_SOURCE)/utils.c

PROOF_SOURCES += $(PROOF_STUB)/error.c
PROOF_SOURCES += $(PROOF_STUB)/memcpy_override_havoc.c
PROOF_SOURCES += $(PROOF_STUB)/s_swap_override_no_op.c

PROJECT_SOURCES += $(SRCDIR)/source/array_list.c
PROJECT_SOURCES += $(SRCDIR)/source/common.c
PROJECT_SOURCES += $(SRCDIR)/source/priority_queue.c

REMOVE_FUNCTION_BODY +=  __CPROVER_file_local_priority_queue_c_s_swap

###########

include ../Makefile.common

=== verification/cbmc/proofs/aws_ring_buffer_release/Makefile ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.

###########
UNWINDSET +=

CBMCFLAGS +=

PROOF_UID = aws_ring_buffer_release
HARNESS_ENTRY = $(PROOF_UID)_harness
HARNESS_FILE = $(PROOFDIR)/$(HARNESS_ENTRY).c

PROOF_SOURCES += $(HARNESS_FILE)
PROOF_SOURCES += $(PROOF_SOURCE)/make_common_data_structures.c
PROJECT_SOURCES += $(SRCDIR)/source/allocator.c
PROOF_SOURCES += $(PROOF_SOURCE)/utils.c

PROOF_SOURCES += $(PROOF_STUB)/error.c

PROJECT_SOURCES += $(SRCDIR)/source/byte_buf.c
PROJECT_SOURCES += $(SRCDIR)/source/ring_buffer.c
PROJECT_SOURCES += $(SRCDIR)/source/common.c

###########

include ../Makefile.common

=== verification/cbmc/proofs/aws_string_eq_byte_cursor/Makefile ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.

include ../Makefile.aws_string

UNWINDSET += memcmp.0:$(shell echo $$(($(MAX_STRING_LEN) + 1)))

CBMCFLAGS +=

PROOF_UID = aws_string_eq_byte_cursor
HARNESS_ENTRY = $(PROOF_UID)_harness
HARNESS_FILE = $(PROOFDIR)/$(HARNESS_ENTRY).c

PROOF_SOURCES += $(HARNESS_FILE)
PROOF_SOURCES += $(PROOF_SOURCE)/make_common_data_structures.c
PROJECT_SOURCES += $(SRCDIR)/source/allocator.c
PROOF_SOURCES += $(PROOF_SOURCE)/utils.c

PROJECT_SOURCES += $(SRCDIR)/source/byte_buf.c
PROJECT_SOURCES += $(SRCDIR)/source/common.c
PROJECT_SOURCES += $(SRCDIR)/source/error.c
PROJECT_SOURCES += $(SRCDIR)/source/string.c

include ../Makefile.common

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=aws-c-common
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.10.0
pkgrel=1
pkgdesc="Core c99 package for AWS SDK for C. Includes cross-platform primitives, configuration, data structures, and error handling (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/awslabs/aws-c-common"
msys2_reference=(
  'archlinux: aws-c-common'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
conflicts=("${MINGW_PACKAGE_PREFIX}-aws-sdk-cpp<1.8.149")
source=("${url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-fix-build-on-mingw-aarch64.patch)
sha256sums=('1fc7dea83f1d5a4b6fa86e3c8458200ed6e7f69c65707aa7b246900701874ad1'
            '557d98a656070bb9b15112c36c1fbc4162bbc100e1b211c97807ca99f431dd3d')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  tar -xf "${srcdir}/${_realname}-${pkgver}.tar.gz" -C "${srcdir}" 2>/dev/null || true

  cd "${srcdir}/${_realname}-${pkgver}"
  patch -p1 -i "${srcdir}"/001-fix-build-on-mingw-aarch64.patch

  # Workaround for build failure in clang due to non-ascii file names
  rm -f tests/resources/* || true
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  CFLAGS+=" -Wno-format" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DBUILD_SHARED_LIBS=OFF \
    -DBUILD_TESTING=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  CFLAGS+=" -Wno-format" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_TESTING=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"

  cd "${srcdir}/build-${MSYSTEM}-shared"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  PATH=$PWD:$PATH ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"
}

package() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
